import { Column, DefaultPlatform, ForeignKey, Sql, Table, TableDiff } from '@deepkit/sql';
import { ReflectionClass, ReflectionProperty, Serializer } from '@deepkit/type';
import { SQLiteSchemaParser } from './sqlite-schema-parser';
import { SQLiteFilterBuilder } from './sql-filter-builder.sqlite';
export declare class SQLitePlatform extends DefaultPlatform {
    protected defaultSqlType: string;
    protected annotationId: string;
    schemaParserType: typeof SQLiteSchemaParser;
    readonly serializer: Serializer;
    constructor();
    quoteValue(value: any): string;
    applyLimitAndOffset(sql: Sql, limit?: number, offset?: number): void;
    createSqlFilterBuilder(schema: ReflectionClass<any>, tableName: string): SQLiteFilterBuilder;
    getModifyTableDDL(diff: TableDiff): string[];
    protected getMigrationTableDDL(diff: TableDiff): string[];
    protected setColumnType(column: Column, typeProperty: ReflectionProperty): void;
    /**
     * Unfortunately, SQLite does not support composite pks where one is AUTOINCREMENT,
     * so we have to flag both as NOT NULL and create in either way a UNIQUE constraint over pks since
     * those UNIQUE is otherwise automatically created by the sqlite engine.
     */
    normalizeTables(tables: Table[]): void;
    supportsInlinePrimaryKey(): boolean;
    getSchemaDelimiter(): string;
    getBeginDDL(): string;
    getEndDDL(): string;
    getAutoIncrement(): string;
    getColumnDDL(column: Column): string;
    getForeignKeyDDL(foreignKey: ForeignKey): string;
}
