"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.databaseFactory = void 0;
const orm_1 = require("@deepkit/orm");
const sqlite_adapter_1 = require("../src/sqlite-adapter");
const fs_1 = require("fs");
const path_1 = require("path");
exports.databaseFactory = Object.assign(async (entities) => {
    const adapter = new sqlite_adapter_1.SQLiteDatabaseAdapter((0, path_1.join)((0, fs_1.mkdtempSync)('/tmp/', 'utf8'), 'db.sqlite'));
    const database = new orm_1.Database(adapter);
    if (entities)
        database.registerEntity(...entities);
    await adapter.createTables(database.entityRegistry);
    return database;
}, { __type: ['entities', () => orm_1.Database, '', 'P"2!P7"`/#'] });
//# sourceMappingURL=factory.js.map