"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const orm_integration_1 = require("@deepkit/orm-integration");
const type_1 = require("@deepkit/type");
//User, Group, UserGroup have a relatively complex circular reference with runtime typeof, which makes it a good candidate to check if all parents and refs are correctly set
(0, globals_1.test)('check type structure', () => {
    // const entities = [User, UserCredentials, Group, UserGroup];
    const user = type_1.ReflectionClass.from(orm_integration_1.User);
    const group = type_1.ReflectionClass.from(orm_integration_1.Group);
    const userGroup = type_1.ReflectionClass.from(orm_integration_1.UserGroup);
    (0, globals_1.expect)(userGroup.getProperty('id').isPrimaryKey()).toBe(true);
    (0, globals_1.expect)(userGroup.getProperty('user').isReference()).toBe(true);
    (0, globals_1.expect)(userGroup.getProperty('user').getKind()).toBe(20 /* class */);
    (0, globals_1.expect)(userGroup.getProperty('user').getResolvedReflectionClass().getPrimary()).toBeInstanceOf(type_1.ReflectionProperty);
    (0, globals_1.expect)(userGroup.getProperty('group').isReference()).toBe(true);
    (0, globals_1.expect)(userGroup.getProperty('group').getResolvedReflectionClass().getPrimary()).toBeInstanceOf(type_1.ReflectionProperty);
    (0, globals_1.expect)(userGroup.type.parent).toBeUndefined();
    const groupsType = user.getProperty('groups').type;
    const userGroupsElementType = user.getProperty('groups').getSubType();
    //due to a change in copyAndSetParent being shallow copy only this is no longer true
    // expect(userGroupsElementType.parent === groupsType).toBe(true);
});
//# sourceMappingURL=integration-types.spec.js.map