"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const { __ΩEntity } = require('@deepkit/type');
const { __ΩAutoIncrement } = require('@deepkit/type');
const { __ΩPrimaryKey } = require('@deepkit/type');
const { __ΩSQLite } = require('@deepkit/type');
const { __ΩUnique } = require('@deepkit/type');
const { __ΩReference } = require('@deepkit/type');
const globals_1 = require("@jest/globals");
const sql_1 = require("@deepkit/sql");
const type_1 = require("@deepkit/type");
const sqlite_adapter_1 = require("../src/sqlite-adapter");
const orm_1 = require("@deepkit/orm");
(0, globals_1.test)('custom type', async () => {
    const __ΩPost = [() => __ΩEntity, "post", 'name', () => __ΩAutoIncrement, () => __ΩPrimaryKey, 'id', () => __ΩSQLite, "text", 'type', 'slug', 'content', () => __ΩSQLite, "integer(4)", 'size', 'float', 'PP."4#Mo!"P(!n$n%K4&P&P.(4)Mo\'"K4*&4+P\'P.-4)Mo,"K4.\'4/M'];
    const adapter = new sqlite_adapter_1.SQLiteDatabaseAdapter(':memory:');
    const [postTable] = adapter.platform.createTables(orm_1.DatabaseEntityRegistry.from([(0, type_1.typeOf)([], [() => __ΩPost, 'n!'])]));
    (0, globals_1.expect)(postTable.getColumn('id').type).toBe('integer');
    (0, globals_1.expect)(postTable.getColumn('slug').type).toBe('text');
    (0, globals_1.expect)(postTable.getColumn('size').type).toBe('integer');
    (0, globals_1.expect)(postTable.getColumn('size').size).toBe(4);
    (0, globals_1.expect)(postTable.getColumn('content').type).toBe('text');
    (0, globals_1.expect)(postTable.getColumn('float').type).toBe('float');
    await (0, sql_1.schemaMigrationRoundTrip)([(0, type_1.typeOf)([], [() => __ΩPost, 'n!'])], adapter);
});
const __ΩUser = [() => __ΩEntity, "user", 'name', () => __ΩAutoIncrement, () => __ΩPrimaryKey, 'id', () => __ΩUnique, 'username', 'created', 'deleted', 'logins', 'PP."4#Mo!"P\'n$n%K4&P&n\'K4(T4))4*\'4+M'];
const __ΩPost = [() => __ΩEntity, "post", 'name', () => __ΩAutoIncrement, () => __ΩPrimaryKey, 'id', () => __ΩUser, () => __ΩReference, 'user', 'created', () => __ΩUnique, 'slag', 'title', 'content', 'PP."4#Mo!"P\'n$n%K4&Pn\'n(K4)T4*P&n+K4,&4-&4.M'];
(0, globals_1.test)('sqlite', async () => {
    await (0, sql_1.schemaMigrationRoundTrip)([(0, type_1.typeOf)([], [() => __ΩUser, 'n!']), (0, type_1.typeOf)([], [() => __ΩPost, 'n!'])], new sqlite_adapter_1.SQLiteDatabaseAdapter(':memory:'));
});
//# sourceMappingURL=migration.spec.js.map