import { Database } from '@deepkit/orm';
import { SQLiteDatabaseAdapter } from '../src/sqlite-adapter';
import { mkdtempSync } from 'fs';
import { join } from 'path';
export const databaseFactory = Object.assign(async (entities) => {
    const adapter = new SQLiteDatabaseAdapter(join(mkdtempSync('/tmp/', 'utf8'), 'db.sqlite'));
    const database = new Database(adapter);
    if (entities)
        database.registerEntity(...entities);
    await adapter.createTables(database.entityRegistry);
    return database;
}, { __type: ['entities', () => Database, '', 'P"2!P7"`/#'] });
//# sourceMappingURL=factory.js.map