import { __ΩEntity as __ΩEntity } from '@deepkit/type';
import { __ΩAutoIncrement as __ΩAutoIncrement } from '@deepkit/type';
import { __ΩPrimaryKey as __ΩPrimaryKey } from '@deepkit/type';
import { __ΩSQLite as __ΩSQLite } from '@deepkit/type';
import { __ΩUnique as __ΩUnique } from '@deepkit/type';
import { __ΩReference as __ΩReference } from '@deepkit/type';
import { expect, test } from '@jest/globals';
import { schemaMigrationRoundTrip } from '@deepkit/sql';
import { typeOf } from '@deepkit/type';
import { SQLiteDatabaseAdapter } from '../src/sqlite-adapter';
import { DatabaseEntityRegistry } from '@deepkit/orm';
test('custom type', async () => {
    const __ΩPost = [() => __ΩEntity, "post", 'name', () => __ΩAutoIncrement, () => __ΩPrimaryKey, 'id', () => __ΩSQLite, "text", 'type', 'slug', 'content', () => __ΩSQLite, "integer(4)", 'size', 'float', 'PP."4#Mo!"P(!n$n%K4&P&P.(4)Mo\'"K4*&4+P\'P.-4)Mo,"K4.\'4/M'];
    const adapter = new SQLiteDatabaseAdapter(':memory:');
    const [postTable] = adapter.platform.createTables(DatabaseEntityRegistry.from([typeOf([], [() => __ΩPost, 'n!'])]));
    expect(postTable.getColumn('id').type).toBe('integer');
    expect(postTable.getColumn('slug').type).toBe('text');
    expect(postTable.getColumn('size').type).toBe('integer');
    expect(postTable.getColumn('size').size).toBe(4);
    expect(postTable.getColumn('content').type).toBe('text');
    expect(postTable.getColumn('float').type).toBe('float');
    await schemaMigrationRoundTrip([typeOf([], [() => __ΩPost, 'n!'])], adapter);
});
const __ΩUser = [() => __ΩEntity, "user", 'name', () => __ΩAutoIncrement, () => __ΩPrimaryKey, 'id', () => __ΩUnique, 'username', 'created', 'deleted', 'logins', 'PP."4#Mo!"P\'n$n%K4&P&n\'K4(T4))4*\'4+M'];
const __ΩPost = [() => __ΩEntity, "post", 'name', () => __ΩAutoIncrement, () => __ΩPrimaryKey, 'id', () => __ΩUser, () => __ΩReference, 'user', 'created', () => __ΩUnique, 'slag', 'title', 'content', 'PP."4#Mo!"P\'n$n%K4&Pn\'n(K4)T4*P&n+K4,&4-&4.M'];
test('sqlite', async () => {
    await schemaMigrationRoundTrip([typeOf([], [() => __ΩUser, 'n!']), typeOf([], [() => __ΩPost, 'n!'])], new SQLiteDatabaseAdapter(':memory:'));
});
//# sourceMappingURL=migration.spec.js.map